<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/FileTree.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/FileTree.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/FileTree.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno"> 8</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">import</span> os.path</span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/FileTree/Node.html">Node</a>:</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Base class for directories and files in the tree.</span></span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-string">    @attr path the path of this node as a string.</span></span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="py-string">    @attr filename the name of the node, i.e. the last element of the</span></span>
<a id="line15"></a><span class="lineno">15</span><span class="line"><span class="py-string">    path string</span></span>
<a id="line16"></a><span class="lineno">16</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line17"></a><span class="lineno">17</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/FileTree/Node.html#__init__">__init__</a>(self, path, filename):</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        self.path = path</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        self.filename = filename</span>
<a id="line20"></a><span class="lineno">20</span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/FileTree/Directory.html">Directory</a>(Node):</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">    <span class="py-string">&quot;&quot;&quot;FileTree node for directories.</span></span>
<a id="line23"></a><span class="lineno">23</span><span class="line"><span class="py-string">    @attr path the path of this node as a string.</span></span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="py-string">    @attr filename the name of the directory, i.e. the last element of the</span></span>
<a id="line25"></a><span class="lineno">25</span><span class="line"><span class="py-string">    path string</span></span>
<a id="line26"></a><span class="lineno">26</span><span class="line"><span class="py-string">    @attr children the children of this directory, each Directory or File</span></span>
<a id="line27"></a><span class="lineno">27</span><span class="line"><span class="py-string">    objects.</span></span>
<a id="line28"></a><span class="lineno">28</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line29"></a><span class="lineno">29</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/FileTree/Directory.html#__init__">__init__</a>(self, path, filename):</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">        Node.__init__(self, path, filename)</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">        self.children = []</span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/FileTree/File.html">File</a>(Node):</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">    <span class="py-string">&quot;&quot;&quot;FileTree node for files.</span></span>
<a id="line35"></a><span class="lineno">35</span><span class="line"><span class="py-string">    @attr path the path of this node as a string.</span></span>
<a id="line36"></a><span class="lineno">36</span><span class="line"><span class="py-string">    @attr filename the name of the file, i.e. the last element of the</span></span>
<a id="line37"></a><span class="lineno">37</span><span class="line"><span class="py-string">    path string</span></span>
<a id="line38"></a><span class="lineno">38</span><span class="line"><span class="py-string">    @attr decls the list of declarations in this file.</span></span>
<a id="line39"></a><span class="lineno">39</span><span class="line"><span class="py-string">    &quot;&quot;&quot;</span></span>
<a id="line40"></a><span class="lineno">40</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/FileTree/File.html#__init__">__init__</a>(self, path, filename, declarations):</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        Node.__init__(self, path, filename)</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        self.declarations = declarations</span>
<a id="line43"></a><span class="lineno">43</span>
<a id="line44"></a><span class="lineno">44</span><span class="line"><span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/FileTree.html#make_file_tree">make_file_tree</a>(files):</span>
<a id="line45"></a><span class="lineno">45</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">    tmp_dirs = {}</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">    root = Directory(<span class="py-string">''</span>, <span class="py-string">''</span>)</span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">    <span class="py-keyword">def</span> insert_dir(path):</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Recursively add a directory to the tree&quot;&quot;&quot;</span></span>
<a id="line51"></a><span class="lineno">51</span><span class="line">        parent_dir, filename = os.path.split(path)</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        <span class="py-keyword">if</span> parent_dir == path:</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">            <span class="py-comment"># The root directory is added below the root node</span></span>
<a id="line54"></a><span class="lineno">54</span><span class="line">            <span class="py-comment"># This is in case absolute filenames are mixed with relative ones</span></span>
<a id="line55"></a><span class="lineno">55</span><span class="line">            parent = root</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">            filename = <span class="py-string">'/'</span></span>
<a id="line57"></a><span class="lineno">57</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">            parent_dir, filename = os.path.split(path)</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">            <span class="py-keyword">if</span> parent_dir:</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">                <span class="py-keyword">if</span> tmp_dirs.has_key(parent_dir):</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">                    parent = tmp_dirs[parent_dir]</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">                    parent = insert_dir(parent_dir)</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">             <span class="py-comment"># No parent means a relative name like 'home/foo/bar'</span></span>
<a id="line66"></a><span class="lineno">66</span><span class="line">             parent = root</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">        new_dir = Directory(path, filename)</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">        tmp_dirs[path] = new_dir</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">        parent.children.append(new_dir)</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">        <span class="py-keyword">return</span> new_dir</span>
<a id="line71"></a><span class="lineno">71</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">    <span class="py-keyword">def</span> insert_file(file, declarations):</span>
<a id="line73"></a><span class="lineno">73</span><span class="line">        parent_dir, filename = os.path.split(file)</span>
<a id="line74"></a><span class="lineno">74</span><span class="line">        <span class="py-keyword">if</span> parent_dir:</span>
<a id="line75"></a><span class="lineno">75</span><span class="line">            <span class="py-keyword">if</span> tmp_dirs.has_key(parent_dir):</span>
<a id="line76"></a><span class="lineno">76</span><span class="line">                parent = tmp_dirs[parent_dir]</span>
<a id="line77"></a><span class="lineno">77</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line78"></a><span class="lineno">78</span><span class="line">                parent = insert_dir(parent_dir)</span>
<a id="line79"></a><span class="lineno">79</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line80"></a><span class="lineno">80</span><span class="line">            <span class="py-comment"># No parent means an relative name like 'home/foo/bar'</span></span>
<a id="line81"></a><span class="lineno">81</span><span class="line">            parent = root</span>
<a id="line82"></a><span class="lineno">82</span><span class="line">        new_file = File(file, filename, declarations)</span>
<a id="line83"></a><span class="lineno">83</span><span class="line">        parent.children.append(new_file)</span>
<a id="line84"></a><span class="lineno">84</span>
<a id="line85"></a><span class="lineno">85</span>
<a id="line86"></a><span class="lineno">86</span><span class="line">    <span class="py-keyword">for</span> f <span class="py-keyword">in</span> files:</span>
<a id="line87"></a><span class="lineno">87</span><span class="line">        <span class="py-keyword">if</span> f.annotations[<span class="py-string">'primary'</span>]:</span>
<a id="line88"></a><span class="lineno">88</span><span class="line">            insert_file(f.name, f.declarations)</span>
<a id="line89"></a><span class="lineno">89</span>
<a id="line90"></a><span class="lineno">90</span><span class="line">    <span class="py-keyword">return</span> root</span>
<a id="line91"></a><span class="lineno">91</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
